export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addInput("LONG", InputType.int, 80);
        this.addInput("SHORT", InputType.int, 21);
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            ExtMapBuffer1 : this.addBuffer(),
            ExtMapBuffer2 : this.addBuffer()
        };



    }

    onInit() {
        let {LONG, SHORT} = this.getInputs();

        this.buffers.ExtMapBuffer1
            .setShape(Shape.Line)
            .setColor(Color.Green)
            .setShortName("Trand(" + LONG + "," + SHORT + ")")
        ;

        this.buffers.ExtMapBuffer2
            .setShape(Shape.Line)
            .setColor(Color.Red)
            .setShortName("Trand(" + LONG + "," + SHORT + ")")
        ;
    }

    async onUpdate() {
        const  {LONG, SHORT} = this.getInputs(),
            {ExtMapBuffer1, ExtMapBuffer2, PriceType} = this.buffers;

        let countedBars = Bar.counted(),
            ZNAK, MALONG, MALONG2, MASHORT, MASHORT2, RAZNICA, RAZNICA2, PERCENT, i, list1 ,list2,
            {Close} = await Bar.load([Bar.Mode.Close], PriceType),
            barSize = Close.length;

        i = barSize - countedBars - 1;

        list1 = await Indicators.MA(null, 0, LONG, 0, Averaging.Exponential, AppliedPrice.Close, PriceType);
        list2 = await Indicators.MA(null, 0, SHORT, 0, Averaging.Exponential, AppliedPrice.Close, PriceType);

        while (i >= 0) {
            MALONG = list1[i];
            MALONG2 = list1[i + SHORT - 1];
            MASHORT = list2[i];
            MASHORT2 = list2[i + SHORT - 1];
            RAZNICA = Math.abs(Math.abs(MALONG - MASHORT) - Math.abs(MALONG - MASHORT2));
            RAZNICA2 = Math.abs(MALONG - MASHORT) + Math.abs(MALONG2 - MASHORT2) / 2;
            PERCENT = RAZNICA * 100 * ((MALONG + MALONG2) / 2) * RAZNICA2;
            if (Math.abs(MALONG - MASHORT) - Math.abs(MALONG - MASHORT2) < 0) {
                ZNAK = -1;
            } else {
                ZNAK = 1;
            }
            ExtMapBuffer1.set(i, (PERCENT * ZNAK));
            ExtMapBuffer2.set(i, ((MASHORT - MALONG) + (MALONG - MALONG2)));
            i--;
        }

    }
}